#/////////////////////////////////////////////////////////////////////////////////
#  WARRANTY: NONE. THIS PROGRAM WAS WRITTEN AS "SHAREWARE" AND IS AVAILABLE AS IS
#            AND MAY NOT WORK AS ADVERTISED IN ALL ENVIRONMENTS. THERE IS NO
#            SUPPORT FOR THIS PROGRAM
#      NOTE: YOU ARE STRONGLY ADVISED TO BACKUP YOUR DESIGN
#            BEFORE RUNNING THIS PROGRAM
#  TCL file: capEagleImport.tcl
#            Sample Tcl/Tk Application Launcher Framework
#/////////////////////////////////////////////////////////////////////////////////

namespace eval capEagleImport {
	variable mForm
	variable mDesignPath
	variable mDesignPath
	variable mOutputPath
	variable initialpath
	variable initialout
	variable CadEXE
	variable eagleconfig
}


package require capApps
package require capAppUtils 
package provide capSessionUtil 
package provide capEagleImport 16.6

proc capEagleImport::getDisclaimerText {} {
    set lDisclaimer { 
WARRANTY: NONE. THESE PROGRAMS WERE WRITTEN AS "SHAREWARE" AND
ARE AVAILABLE "AS IS" AND MAY NOT WORK AS ADVERTISED IN
ALL ENVIRONMENTS. THERE IS NO SUPPORT FOR THESE
PROGRAMS.

NOTE: YOU ARE STRONGLY ADVISED TO BACKUP YOUR DESIGNS AND/OR
LIBRARIES BEFORE RUNNING THESE PROGRAMS. 
    }
	
    return $lDisclaimer
}

proc capEagleImport::main {pForm} {
    
	set ft [font create -family Helvetica -size 9 -weight bold]
	set ft1 [font create -family Helvetica -size 9 -weight normal]
	set ft2 [font create -family Helvetica -size 12 -weight normal]
	
    set ::capEagleImport::mForm $pForm
    
	# For Static Text space line
    variable lLabelspace1 [label $pForm.lLabelspace1 \
	    -text ""]
	
	# For Static Text space line
    variable lLabelspace2 [label $pForm.lLabelspace2 \
	    -text "    "]
	
	# For Static Text space line
    variable lLabelspace3 [label $pForm.lLabelspace3 \
	    -text "    "]
	
	# For Static Text 'Design Path'
    variable lLabelDesignPath [label $pForm.lLabelDesignPath \
	    -font $ft -text "Eagle .sch file"]
	    
	# For Static Text 'Design Path'
    variable lLabelOutputPath [label $pForm.lLabelOutputPath \
	    -font $ft -text "OrCAD output path     "]
	    
	# For Static Text leave blank
    variable lLabelBlankmessage [label $pForm.lLabelBlankmessage \
	    -justify "left" \
	    -font $ft1 -text "Leave this field blank if the output files are located in the same directory as the source (.sch) file"]
	    
	# For Static Text 'Cleanup intermediate files'
    variable lLabelCheckClean [label $pForm.lLabelCheckClean \
	    -font $ft -text "Cleanup intermediate files"]
	    
	# For Static Text 'Force labels'
    variable lLabelForceLabel [label $pForm.lLabelForceLabel \
	    -font $ft -text "Force labels on unconnected wires"]
	    
    set lState "normal"
    
	# Check box for Clean 
    variable lCheckClean [checkbutton $pForm.lCheckClean \
	    -text ""]
	    
	# Check box for Force Label 
    variable lForceLabel [checkbutton $pForm.lForceLabel \
	    -text ""]
	    
	# For Text Box for 'Design Path'
    variable lDesignPath [entry $pForm.lDesignPath \
	    -textvariable "::capEagleImport::mDesignPath" \
		-font $ft2 \
	    -state $lState \
	    -width 60 \
	    ]
    
	# For Text Box for 'Output Path'
    variable lOutputPath [entry $pForm.lOutputPath \
	    -textvariable "::capEagleImport::mOutputPath" \
		-font $ft2 \
	    -state $lState \
	    -width 60 \
	    ]
    
	# Browse Button for 'Design Path'
    variable lBtnDesignPath [button $pForm.lBtnDesignPath \
	    -command "capEagleImport::doChooseDesignFile" \
	    -borderwidth 1 \
	    -state $lState \
	    -width 8 \
		-font $ft \
	    -text ". . ."]
    
    variable lBtnOutputPath [button $pForm.lBtnOutputPath \
	    -command "capEagleImport::doChooseOutputDir" \
	    -borderwidth 1 \
	    -state $lState \
	    -width 8 \
		-font $ft \
	    -text ". . ."]
    
    set lState "normal"
    
	# 'Ok' button
    variable lBtnE2C [button $pForm.lBtnE2C \
	    -command "capEagleImport::doEagleConvert" \
	    -state $lState \
	    -width 12 \
	    -font $ft -text "Translate"]
    
	# 'Cancel' Button
    variable lBtnCancel [button $pForm.lBtnCancel \
	    -command "capEagleImport::cancelEagleConvert" \
	    -width 12 \
	    -font $ft -text "Cancel"]
    
 	# 'View Log' button
    variable lBtnViewLog [button $pForm.lBtnViewLog \
	    -command "capEagleImport::doEagleConvert" \
	    -width 12 \
	    -state disabled \
	    -font $ft -text "View Log"]
    
 	# 'Help' button
    variable lBtnHelp [button $pForm.lBtnHelp \
	    -command "capEagleImport::doOpenHelp" \
	    -state $lState \
	    -width 8 \
	    -font $ft -text "Help"]
    
   # Geometry Management

		# some space 
    grid $pForm.lLabelspace2 -in $pForm -row 2 -column 1 \
	    -columnspan 1 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"

	# The static text label "Design Path"
    grid $pForm.lLabelDesignPath -in $pForm -row 2 -column 2 \
	    -columnspan 1 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"
	
	# The Text box for "Design Path"
    grid $pForm.lDesignPath -in $pForm -row 2 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "ew"

		# original browse button style
	    #-activebackground "#00ffff" \
	    #-anchor "ne" \
	    #-compound "left" \
	    #-cursor "arrow" \
	    #-default "active" \
	    #-justify "left" \
	    #-padx 0 \
	    #-pady 0 \

		# some space 
    grid $pForm.lLabelspace3 -in $pForm -row 2 -column 5 \
	    -columnspan 1 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"

		# The browse button for Design Path
    grid $pForm.lBtnDesignPath -in $pForm -row 2 -column 6 \
	    -columnspan 1 \
	    -ipadx 1 \
	    -ipady 1 \
	    -padx 1 \
	    -pady 1 \
	    -rowspan 1 \
	    -sticky ""
	
		# some space 
    grid $pForm.lLabelspace2 -in $pForm -row 2 -column 7 \
	    -columnspan 1 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"
	# The static text label "Output Path"
    grid $pForm.lLabelOutputPath -in $pForm -row 4 -column 2 \
	    -columnspan 1 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"
	
	
	# The Text box for "Output Path"
    grid $pForm.lOutputPath -in $pForm -row 4 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "ew"
	
	# The browse button for Design Path
    grid $pForm.lBtnOutputPath -in $pForm -row 4 -column 6 \
	    -columnspan 1 \
	    -ipadx 1 \
	    -ipady 1 \
	    -padx 1 \
	    -pady 1 \
	    -rowspan 1 \
	    -sticky ""
	
	# Frame to hold the 'Translate' and 'Cancel' button
    #variable lLabelFrameButtons [labelframe $pForm.lLabelFrameButtons ]
	# The label frame to put the buton 'Translate', 'Cancel
    #grid $pForm.lLabelFrameButtons -in $pForm -row 4 -column 2 \
	#    -columnspan 1 \
	#    -ipadx 0 \
	#    -ipady 0 \
	#    -padx 0 \
	#    -pady 0 \
	#    -rowspan 1 \
	#    -sticky "news"
		
		
	# The static text label "leave blank"
    grid $pForm.lLabelBlankmessage -in $pForm -row 5 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"
		
	# The static text label for clean
    grid $pForm.lLabelCheckClean -in $pForm -row 6 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"

	# The Checkbox for clean
    grid $pForm.lCheckClean -in $pForm -row 6 -column 2 \
	    -sticky "w"
		
	# The static text label for clean
    grid $pForm.lLabelForceLabel -in $pForm -row 7 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"

	# The Checkbox for clean
    grid $pForm.lForceLabel -in $pForm -row 7 -column 2 \
	    -sticky "w"
		
	# The static text label for clean
    grid $pForm.lLabelspace1 -in $pForm -row 8 -column 3 \
	    -columnspan 2 \
	    -ipadx 0 \
	    -ipady 0 \
	    -padx 0 \
	    -pady 0 \
	    -rowspan 1 \
	    -sticky "w"

	# For 'Translate' button inside label frame
    grid $pForm.lBtnE2C -in $pForm -row 10 -column 2 \
	    -columnspan 1 \
	    -ipadx 1 \
	    -ipady 1 \
	    -padx 2 \
	    -pady 2 \
	    -rowspan 1 \
	    -sticky "w"
		
	# For 'Cancel' button inside label frame
    grid $pForm.lBtnCancel -in $pForm -row 10 -column 4 \
	    -columnspan 1 \
	    -ipadx 1 \
	    -ipady 1 \
	    -padx 2 \
	    -pady 2 \
	    -rowspan 1 \
	    -sticky "w"
    
	# For 'Translate' button inside label frame
    grid $pForm.lBtnHelp -in $pForm -row 10 -column 6 \
	    -columnspan 1 \
	    -ipadx 1 \
	    -ipady 1 \
	    -padx 2 \
	    -pady 2 \
	    -rowspan 1 \
	    -sticky "w"
		
    # Resize Behavior
    grid rowconfigure $pForm 1 -weight 0 -minsize 21 -pad 0
    grid rowconfigure $pForm 2 -weight 0 -minsize 21 -pad 0
    grid rowconfigure $pForm 2 -weight 0 -minsize 9 -pad 0
    grid columnconfigure $pForm 1 -weight 0 -minsize 10 -pad 0
    grid columnconfigure $pForm 2 -weight 1 -minsize 40 -pad 0
    grid columnconfigure $pForm 3 -weight 0 -minsize 10 -pad 0
    #grid rowconfigure $pForm.lLabelFrameButtons 1 -weight 0 -minsize 12 -pad 0
    #grid columnconfigure $pForm.lLabelFrameButtons 1 -weight 0 -minsize 12 -pad 0
    #grid columnconfigure $pForm.lLabelFrameButtons 2 -weight 0 -minsize 12 -pad 0
    #grid columnconfigure $pForm.lLabelFrameButtons 3 -weight 0 -minsize 12 -pad 0
	
}

proc capEagleImport::doOpenHelp {  } {
	#set CadPath $::env(CDSROOT)
	set CadPath [file normalize [info nameofexecutable]]
	set CadPath [string map {"/tools/capture/Capture.exe" ""} $CadPath]
	set CadPath [string map {"/tools/bin/Capture.exe" ""} $CadPath]

	append CadPath "/tools/capture/tclscripts/capEagleImport/Help"	

	#set CadPath [string range $CadPath 2 end] 
	set i [expr [string first "\\" $CadPath]]
	while {$i!=-1} {
		set CadPath [string replace $CadPath $i $i "/"] 
		set i [expr [string first "\\" $CadPath]]
	}
 
	exec cmd.exe /c "$CadPath/EagleImport.pdf" & 
}

proc capEagleImport::doEagleConvert {  } {
	global lCheckClean
	global lForceLabel
	global lForm
	
	set isClean $lCheckClean
	destroy $::capEagleImport::mForm

	set scriptDir $::capEagleImport::CadEXE
	
	set InFile $::capEagleImport::mDesignPath
	if {$InFile==""} return
		 
	#set lDesignPath [DboTclHelper_sMakeCString $InFile 0]
	#set nStatus [DboState] 
	#set nSession [DboTclHelper_sCreateSession]
	#set lDesign [$nSession GetDesign $lDesignPath $nStatus]
	#set lRootOcc [$lDesign GetRootOccurrence $nStatus]
	#capEagleImport::ReadPages $lRootOcc
		
	set EagleFile [string trim $InFile]
	set i [expr [string last "/" $EagleFile] - 1]
	set pathname [string range $EagleFile 0 $i] 
	
	# save path to file
	#set CadPath $::env(CDSROOT)
	set CadPath [file normalize [info nameofexecutable]]
	set CadPath [string map {"/tools/capture/Capture.exe" ""} $CadPath]
	set CadPath [string map {"/tools/bin/Capture.exe" ""} $CadPath]

	append CadPath "/tools/bin/EagleImport"	

	set eagleconfig $::capEagleImport::eagleconfig 
	set fp [open "$eagleconfig/eagleconfig.txt" w]
	puts $fp "oldpath=$pathname"
	puts $fp "outpath=$::capEagleImport::mOutputPath"
	if {$lForceLabel=="1"} {
		puts $fp "forcelabels=yes"
	} else {
		puts $fp "forcelabels=no"
	}
	if {$lCheckClean=="1"} {
		puts $fp "cleaninter=yes"
	} else {
		puts $fp "cleaninter=no"
	}			
	close $fp
	
	set i [expr $i + 2]
	set filename [string range $EagleFile $i end] 
	set i [expr [string last "." $filename] - 1]
	set filename [string range $filename 0 $i] 

	set filename [string map {" " ""} $filename]
	set filename [string map {"&" ""} $filename]

    if { "" != $::capEagleImport::mOutputPath} {
		set pathname $::capEagleImport::mOutputPath
	} 

	if {[file exists "$pathname/EagleImportLog.txt"]} {
		file delete "$pathname/EagleImportLog.txt"
	}

	set forcelabel "no"
	if {$lForceLabel==1} {
		set forcelabel "yes"
	}
	
    if { "" == $::capEagleImport::mOutputPath} {
		set result [catch {exec "$scriptDir/Eagle2Cp.exe" "$InFile" "$forcelabel"} res]
	} else {
		set result [catch {exec "$scriptDir/Eagle2Cp.exe" "$InFile" "$forcelabel" "$::capEagleImport::mOutputPath"} res]
	}
		
	if {$result} {
		set lMessageStr [DboTclHelper_sMakeCString $res]
		DboState_WriteToSessionLog $lMessageStr
	} else {
		set xmlolbname $filename 
		append xmlolbname "_olb.xml"
		set olbname $filename 
		append olbname ".olb"
		set xmldsnname $filename 
		append xmldsnname ".xml"
		set dsnname $filename 
		append dsnname ".dsn"
				
		set mfil $pathname
		append mfil "/"
		append mfil $olbname
		if {[file exists $mfil]} {
			file delete $mfil
		}
		set mfil $pathname
		append mfil "/"
		append mfil $dsnname
		if {[file exists $mfil]} {
			file delete $mfil
		}
		
		cd $pathname
		XMATIC_XML2OLB $xmlolbname $olbname
		XMATIC_XML2DSN $xmldsnname $dsnname
			
		if {$isClean==1} {
			if {[file exists $xmlolbname]} {
				file delete $xmlolbname
			}
			if {[file exists $xmldsnname]} {
				file delete $xmldsnname
			}
		}
		
		set myCommand "Open $dsnname"
		if {[file exists $dsnname]} {after idle [list after 0 $myCommand]}

	}
	
	if {[file exists "$pathname/EagleImportLog.txt"]} { 
		catch {exec notepad.exe "$pathname/EagleImportLog.txt" &} res
		#$lForm.lBtnViewLog configure -state normal
	}
	
	#delete_DboSession $nSession
}


proc capEagleImport::cancelEagleConvert {  } {	
	destroy $::capEagleImport::mForm
}

proc capEagleImport::doChooseDesignFile {  } {
	set types {
	    {{Eagle Schema}      {.sch}        }
	}

	set mypath $::capEagleImport::initialpath
	set filename [tk_getOpenFile -initialdir "$mypath" -filetypes $types]
    if { "" == $filename} {
		#capEagleImport::cancelEagleConvert
	} else {
		set ::capEagleImport::mDesignPath $filename
	}
}

proc capEagleImport::doChooseOutputDir {  } {
	set mypath $::capEagleImport::initialout
	set filename [tk_chooseDirectory -initialdir "$mypath"]
    if { "" == $filename} {
		#capEagleImport::cancelEagleConvert
	} else {
		set ::capEagleImport::mOutputPath $filename
		set ::capEagleImport::initialout $filename
	}
}

proc capEagleImport::launchForm {args} {
	global lCheckClean
	global lForceLabel
	global lForm

	wm withdraw .

	# get old path
	#set CadPath $::env(CDSROOT)
	set CadPath [file normalize [info nameofexecutable]]
	set CadPath [string map {"/tools/capture/Capture.exe" ""} $CadPath]
	set CadPath [string map {"/tools/bin/Capture.exe" ""} $CadPath]

	set ::capEagleImport::initialpath $CadPath
	set ::capEagleImport::initialout $CadPath
	append CadPath "/tools/bin/EagleImport"	
	set ::capEagleImport::CadEXE $CadPath
	
	# get program version
	set result [catch {exec "$CadPath/Eagle2Cp.exe" "-build"} version]

	set lCheckClean "1"
	set lForceLabel "1"

	set ::capEagleImport::mOutputPath ""
	
	set eagleconfig [GetIniPath]	
	set eagleconfig [string map {"/Capture.ini" ""} $eagleconfig]
	set eagleconfig [string map -nocase {"\\Capture.ini" ""} $eagleconfig]
	set ::capEagleImport::eagleconfig $eagleconfig

	if {[file exists "$eagleconfig/eagleconfig.txt"]} { 
		set fp [open "$eagleconfig/eagleconfig.txt" r]
		set file_data [read $fp]
		set data [split $file_data "\n"]
		foreach line $data {
			set data1 [split $line "="]
			set cmd [lindex $data1 0]
			set valini [lindex $data1 1]
			if {$cmd=="oldpath"} {
				set ::capEagleImport::initialpath $valini
			}
			if {$cmd=="outpath"} {
				set ::capEagleImport::initialout $valini
				set ::capEagleImport::mOutputPath $valini
			}	
			if {$cmd=="forcelabels"} {
				if {$valini=="yes"} {
					set lForceLabel "1"
				} else {
					set lForceLabel "0"
				}
			}
			if {$cmd=="cleaninter"} {
				if {$valini=="yes"} {
					set lCheckClean "1"
				} else {
					set lCheckClean "0"
				}
			}
		}
		close $fp
	}
	set ::capEagleImport::mDesignPath ""
	
	set mtitle "Import Eagle Schematic "
	append mtitle $version
	
	set lForm .capEagleImport
    capAppUtils::capTopLevel $lForm
    capEagleImport::main $lForm 
    wm title $lForm $mtitle
	capAppUtils::autoAdoptWindow $lForm    

	#$lForm.lBtnViewLog configure -state disabled

	if { 0 == [winfo ismapped $lForm]} {
        wm deiconify $lForm
    }
}

# end of file

